#ifndef __NANOLINK_JS_H__
#define __NANOLINK_JS_H__

#include "ScriptingCore.h"

#ifdef __cplusplus
extern "C" {
#endif
    // 初始化服务器地址
	bool nano_init_ (JSContext * cx, uint32_t argc, jsval *vp);

	// 配置协议参数
    bool nano_config_ (JSContext * cx, uint32_t argc, jsval *vp);

	// 全网匹配接口, 如果 timeout <= 0，默认15秒
	bool nano_connect_ (JSContext * cx, uint32_t argc, jsval *vp);

	// 局域网匹配接口, 同上
	// 如果 group 有效，相当于虚拟局域网匹配
	bool nano_connect2_ (JSContext * cx, uint32_t argc, jsval *vp);

	// 断开连接
	bool nano_disconnect_ (JSContext * cx, uint32_t argc, jsval *vp);

	// 发送指令
	bool nano_send_ (JSContext * cx, uint32_t argc, jsval *vp);

	// 标记
	bool nano_sendmark_ (JSContext * cx, uint32_t argc, jsval *vp);

	// 接收指令，如果缓冲区没有数据等待数据就绪，否则最多堵塞 timeout 时间
	bool nano_recv_ (JSContext * cx, uint32_t argc, jsval *vp);

	// 更新客户端的位置(x,y), 空间(z), 接收增益(k)
	bool nano_update_ (JSContext * cx, uint32_t argc, jsval *vp);

	// 用于替代其他 get 接口, 分别有 字符串形式和long形式
	// 将来有可能取消其他 get 接口
	// latency, last-time, last-error, client-index, is-master, master-index
	bool nano_getInt_ (JSContext * cx, uint32_t argc, jsval *vp);
	// server-id, target-id, client-id, status, stats
	bool nano_getString_ (JSContext * cx, uint32_t argc, jsval *vp);

	// 获得与设置日志数据
	bool nano_load_ (JSContext * cx, uint32_t argc, jsval *vp);
	bool nano_load_ (JSContext * cx, uint32_t argc, jsval *vp);

#ifdef __cplusplus
}
#endif

class nanolink_js {
public:
    static void registerJSFunctions(JSContext * cx, JS::HandleObject global);
};

#endif /* __NANOLINK_JS_H__ */
